MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Related Changesets ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0024803Open CASCADE[OCCT] OCCT:Modeling Algorithmspublic2014-04-07 14:422015-05-14 16:25
Reporteribs 
Assigned Tobugmaster 
PrioritynormalSeverityminor 
StatusclosedResolutionfixed 
PlatformOSOS Version
Product Version[OCCT] 6.7.0 
Target Version[OCCT] 6.9.0Fixed in Version[OCCT] 6.9.0 
Summary0024803: improve the result of v/v interference for two vertices case
DescriptionThe center of enclosing vertex of two vertices is calculated as the center of line connecting these vertices. The radius of enclosing vertex is the distance from enclosing vertex center to the center of being enclosed vertex with maximum radius. (for more details you can read "General Fuse Algorithm,Boolean Operations Algorithm, Partition Algorithm" article, 0024649,chapter 4.1.1. Vertex/Vertex interference)

for case when two vertices have equal radii this approach is correct, but otherwise there is the need to do calculation in a different way.

say, a ball is a vertex with some radius.

if some ball encloses two some other balls. there is a smallest enclosed ball that covers and _touches_ these two balls.

there is the need to calculate the center of enclosing ball and its radius for the case when being enclosing two balls have different radii
Steps To Reproducevertex v1 0 0 0
settolerance v1 1.0

vertex v2 4 0 0
settolerance v2 3.5

bop v1 v2
bopcommon result
tolerance result

dump result
#
# the result is:
...
TShape # 2 : VERTEX 0101101 7EF2FCC0
    Tolerance : 5.5
    - Point 3D : 2, 0, 0
#
# but it should be:
...
TShape # 2 : VERTEX 0101101 7EF2FCC0
    Tolerance : 4.25
    - Point 3D : 3.25, 0, 0

TagsNo tags attached.
Test case numberbugs modalg_6(011) bug24803
Attached Filespng file icon emclosing_vertex.PNG (14,269 bytes) 2015-03-24 18:39
png file icon enclosing_vertex_corrected.PNG (12,530 bytes) 2015-03-24 18:47

- Relationships

-  Notes
(0038854)
msv (developer)
2015-03-24 18:48

Two attached pictures show the current (invalid) enclosing vertex and corrected one.
(0038888)
msv (developer)
2015-03-25 14:20

Dear Peter, please take care of this issue.
(0039180)
git (administrator)
2015-04-03 07:27

Branch CR24803_1 has been created by pkv.

SHA-1: c1e0171c58de4f81b0fc4fd5e0d5ea31876252b8


No new revisions were added by this update.
(0039181)
git (administrator)
2015-04-03 07:28

Branch CR24803_1 has been updated by pkv.

SHA-1: e5a77b76b2d8d2f4b6c1b3af5a96331caadefc84


Detailed log of new commits:

Author: pkv
Date: Fri Apr 3 07:28:18 2015 +0300

    0024803: improve the result of v/v interference for two vertices case
    
    I. New features:
       No new features.
    
    II. Changes:
    II.1. class BOPTools_AlgoTools
    - method:
    void BOPTools_AlgoTools::MakeVertex(BOPCol_ListOfShape& aLV,
                                        TopoDS_Vertex& aVnew)
    has been changed.
    The section for case of two vertices has been added
    
    III. Modified entities:
    packages:
    BOPTools

(0039182)
pkv (developer)
2015-04-03 07:30

Git branch CR24803_1 is ready to be reviewed
(0039183)
pkv (developer)
2015-04-03 07:33

The modification dealt with the case of two vertices.
For the general case of N vertices there is no easy feasible solution for the moment.
(0039184)
emv (developer)
2015-04-03 09:09

Reviewed.
(0039278)
git (administrator)
2015-04-06 19:45

Branch CR24803_1 has been updated forcibly by mkv.

SHA-1: 15763cb2adc8644d96695196f4aea67c7acfe1fd
(0039486)
mkv (tester)
2015-04-09 14:09

Dear BugMaster,
Branch CR24803_1 was rebased on IR-2015-04-06 of occt git-repository.
(0039487)
mkv (tester)
2015-04-09 14:10

Dear BugMaster,
Branch CR24803_1from occt git-repository (and master from products git-repository) was compiled on Linux, MacOS and Windows platforms and tested on Release mode.
SHA-1: 15763cb2adc8644d96695196f4aea67c7acfe1fd

Number of compiler warnings:

occt component :
Linux: 18 (18 on master)
Windows: 0 (0 on master)

products component :
Linux: 4 (4 on master)
Windows: 0 (0 on master)

Regressions/Differences:
No regressions/differences

Testing cases:
http://occt-tests/CR24803-1-master-occt-64/Debian60-64/bugs/modalg_6/bug24803.html [^]
http://occt-tests/CR24803-1-master-occt-64/Windows-64-VC10/bugs/modalg_6/bug24803.html [^]
bugs modalg_6(011) bug24803: OK

Testing on Linux:
occt component :
Total MEMORY difference: 93500517 / 93953474 [-0.48%]
Total CPU difference: 58128.33999999942 / 52005.73999999962 [+11.77%]
products component :
Total MEMORY difference: 23504578 / 23598467 [-0.40%]
Total CPU difference: 17861.999999999967 / 15592.839999999998 [+14.55%]

Testing on Windows:
occt component :
Total MEMORY difference: 57062780 / 57074762 [-0.02%]
Total CPU difference: 15804.835712398952 / 16635.463036899022 [-4.99%]
products component :
Total MEMORY difference: 15307166 / 15311228 [-0.03%]
Total CPU difference: 5741.648005199963 / 6012.5749418999785 [-4.51%]

There are no differences in images found by testdiff.
(0039488)
git (administrator)
2015-04-09 14:10

Branch CR24803_1 has been updated by mkv.

SHA-1: 19a5b5946876e9c8261b61cf10f010e401a184ac


Detailed log of new commits:

Author: mkv
Date: Thu Apr 9 14:06:59 2015 +0300

    Test case for issue CR24803

(0039489)
mkv (tester)
2015-04-09 14:11

Dear BugMaster,
Branch CR24803_1 is TESTED.
(0040947)
git (administrator)
2015-05-14 16:25

Branch CR24803 has been deleted by inv.

SHA-1: 9ad393f13343bd8aa9229f70a35c920f1d9b005a
(0040948)
git (administrator)
2015-05-14 16:25

Branch CR24803_1 has been deleted by inv.

SHA-1: 19a5b5946876e9c8261b61cf10f010e401a184ac

- Related Changesets
occt: master 138ac530
Timestamp: 2015-04-09 13:26:40
Author: pkv
Committer: bugmaster
Details ] Diff ]
0024803: improve the result of v/v interference for two vertices case

Changes:
class BOPTools_AlgoTools
- method:
void BOPTools_AlgoTools::MakeVertex(BOPCol_ListOfShape& aLV,
                                    TopoDS_Vertex& aVnew)
has been changed.
The section for case of two vertices has been added

Test case for issue CR24803
mod - src/BOPTools/BOPTools_AlgoTools.cxx Diff ] File ]
add - tests/bugs/modalg_6/bug24803 Diff ] File ]

- Issue History
Date Modified Username Field Change
2014-04-07 14:42 ibs New Issue
2014-04-07 14:42 ibs Assigned To => ibs
2014-04-07 14:51 ibs Description Updated View Revisions
2014-04-07 14:52 ibs Status new => assigned
2014-04-07 15:13 ibs Description Updated View Revisions
2014-04-07 15:14 ibs Description Updated View Revisions
2014-04-07 15:29 ibs Description Updated View Revisions
2014-04-07 15:50 ibs Description Updated View Revisions
2014-04-11 11:42 abv Product Version 6.8.0 => 6.7.0
2014-04-11 11:42 abv Target Version 6.7.1 => 6.8.0
2014-04-16 16:59 ibs Note Added: 0028885
2014-04-16 16:59 ibs Assigned To ibs => pkv
2014-04-16 16:59 ibs Status assigned => feedback
2014-04-17 10:10 ibs Status feedback => assigned
2014-04-17 10:11 ibs Note Deleted: 0028885
2014-09-26 11:35 abv Target Version 6.8.0 => 7.1.0
2015-03-24 10:32 ibs Assigned To pkv => msv
2015-03-24 10:47 abv Target Version 7.1.0 => 6.9.0
2015-03-24 18:39 msv File Added: emclosing_vertex.PNG
2015-03-24 18:47 msv File Added: enclosing_vertex_corrected.PNG
2015-03-24 18:48 msv Note Added: 0038854
2015-03-25 14:19 msv Assigned To msv => pkv
2015-03-25 14:20 msv Note Added: 0038888
2015-04-03 07:27 git Note Added: 0039180
2015-04-03 07:28 git Note Added: 0039181
2015-04-03 07:29 pkv Status assigned => resolved
2015-04-03 07:30 pkv Note Added: 0039182
2015-04-03 07:30 pkv Assigned To pkv => emv
2015-04-03 07:33 pkv Note Added: 0039183
2015-04-03 07:45 pkv Steps to Reproduce Updated View Revisions
2015-04-03 09:09 emv Note Added: 0039184
2015-04-03 09:09 emv Assigned To emv => mkv
2015-04-03 09:09 emv Status resolved => reviewed
2015-04-06 19:45 git Note Added: 0039278
2015-04-09 14:09 mkv Note Added: 0039486
2015-04-09 14:10 mkv Note Added: 0039487
2015-04-09 14:10 mkv Assigned To mkv => bugmaster
2015-04-09 14:10 mkv Status reviewed => tested
2015-04-09 14:10 git Note Added: 0039488
2015-04-09 14:11 mkv Test case number => bugs modalg_6(011) bug24803
2015-04-09 14:11 mkv Note Added: 0039489
2015-04-10 14:09 bugmaster Changeset attached => occt master 138ac530
2015-04-10 14:09 bugmaster Status tested => verified
2015-04-10 14:09 bugmaster Resolution open => fixed
2015-05-14 15:28 aiv Status verified => closed
2015-05-14 15:31 aiv Fixed in Version => 6.9.0
2015-05-14 16:25 git Note Added: 0040947
2015-05-14 16:25 git Note Added: 0040948


Copyright © 2000 - 2020 MantisBT Team
Powered by Mantis Bugtracker